package com.xx.merchanthbh.ui.point;

import android.app.Application;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.data.http.requst.StorePointsRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.data.http.respons.ConsultationTitleBean;
import com.xx.merchanthbh.data.http.respons.MerchantPointBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.ui.huanbohai.HuanBoHaiViewModel;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class StorePointsViewModel extends BaseViewModel<StorePointsRequest> {
    //头像的绑定
    private MutableLiveData<String> avatarImageUrl = new MutableLiveData<>();

    //    创建积分明细列表实体对象
    public MutableLiveData<List<MerchantPointBean>> merchantPointList =new  MutableLiveData<>(new ArrayList<>());

    //公司名称的绑定
    public ObservableField<String> companyName = new ObservableField<>("");
    //累计积分的绑定
    public ObservableField<String> variableIntegral = new ObservableField<>("");

    public StorePointsViewModel(@NonNull Application application) {
        super(application);
    }

    public StorePointsViewModel(@NonNull Application application, StorePointsRequest model) {
        super(application, model);
    }


    private void setValueToNickName() {
        companyName.set(LocalData.getMerchant().getCompanyName());
        avatarImageUrl.setValue(LocalData.getUser().getAvatar());
        Log.v("还在viewModel滞留的图片", String.valueOf(avatarImageUrl));
    }
    /*头像回显*/
    public LiveData<String> getAvatarImageUrl() {
        return avatarImageUrl;
    }
    public void refreshNickName() {
        setValueToNickName();
    }
//    //调用积分明细的接口信息
    public void getStorePointsList() {
        model.getMerchantPointList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(StorePointsViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<MerchantPointBean>>() {
                    @Override
                    public void onSuccess(List<MerchantPointBean> resultBean) {
                        merchantPointList.postValue(resultBean);
                        variableIntegral.set(String.valueOf(resultBean.get(0).getVariableIntegral()));
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }
}

